<template>
  <div>
  <div v-show="maintain">
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined">新建</a-button>
          <a-button  v-show="showUpBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button v-show="showUpBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showUpBtn">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
      <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'collectionDesc'">
            <JEllipsisFormat :value="record.collectionDesc" :length="60"/>
          </template>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <StCaMainCollectionModal @register="registerModal" @success="handleSuccess"></StCaMainCollectionModal>
  </div>
    <StCaMainRelCollectionList v-show="!maintain" :collectionInfo="maintainRecord" @callBack="rbckHandler" ></StCaMainRelCollectionList>
</div>
</template>

<script lang="ts" name="standardlib-controlactivity-StCaMainCollectionList" setup>
  import { onMounted, ref, toRaw } from 'vue';
import { useRoute } from 'vue-router';
import JEllipsisFormat from '../components/JEllipsisFormat.vue';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StCaMainCollection.api';
import { columns, searchFormSchema } from './StCaMainCollection.data';
import StCaMainRelCollectionList from './StCaMainRelCollectionList.vue';
import StCaMainCollectionModal from './components/StCaMainCollectionModal.vue';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';

  const route = useRoute();
  const showUpBtn = ref(false)
  const maintain = ref(true)
  const maintainRecord = ref({})
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '活动集合',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 200,
               fixed:'right'
            },
            showTableSetting: false,
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc', })
            },
      },
       exportConfig: {
            name:"活动集合",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext

  onMounted(()=>{
    const bizNo = toRaw(route.query).bizNo
    if(!!bizNo){
    // const queryName = toRaw(route.query).bizNo
      setProps({searchInfo:{collectionNo:bizNo}});
      reload()
    }
})
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   function handleMaintain(record) {
     maintain.value = !maintain.value
     maintainRecord.value = record
   }
   function rbckHandler(data){
    maintain.value = true
    // if(data){
    //   setProps({searchInfo:{collectionNo:data.collectionNo}});
    // }else{
    //   setProps({searchInfo:{collectionNo:''}});
    // }
    // reload()
    // 
    // const tableAction = unref(prefixCls);
    // console.log(tableAction)
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
        {
           label: '删除',
           color: 'error',
           popConfirm: {
             title: '你确定要删除选中的活动集合吗？',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '维护',
           onClick: handleMaintain.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
        //  {
        //    label: '详情',
        //    onClick: handleDetail.bind(null, record),
        //  }, 
       ]
   }


</script>

<style scoped>

</style>